import type { _NSArray } from "../Foundation/NSArray.js";
import type { _NSDictionary } from "../Foundation/NSDictionary.js";
import type { _NSError } from "../Foundation/NSError.js";
import type { _NSNumber } from "../Foundation/NSNumber.js";
import type { _NSObject } from "../Foundation/NSObject.js";
import type { _NSString } from "../Foundation/NSString.js";
import type { _NSURL } from "../Foundation/NSURL.js";
import type { _NSImage } from "../AppKit/NSImage.js";
import type { GKGameActivityPlayStyle } from "./GKGameActivityPlayStyle.js";
import type { GKReleaseState } from "./GKReleaseState.js";
export declare class _GKGameActivityDefinition extends _NSObject {
    static alloc(): _GKGameActivityDefinition;
    static new(): _GKGameActivityDefinition;
    init(): _GKGameActivityDefinition;
    /** Loads all the game activity definitions for the current game. */
    static loadGameActivityDefinitionsWithCompletionHandler$(completionHandler: ((activityDefinitions: _NSArray, error: _NSError) => void) | null): void;
    /**
     * Loads game activity definitions with the supplied App Store Connect identifiers.
     */
    static loadGameActivityDefinitionsWithIDs$completionHandler$(activityDefinitionIDs: _NSArray | null, completionHandler: ((activityDefinitions: _NSArray, error: _NSError) => void) | null): void;
    /**
     * Loads all associated achievements that have defined deep links to this game activity definition.
     */
    loadAchievementDescriptionsWithCompletionHandler$(completionHandler: ((achievementDescriptions: _NSArray, error: _NSError) => void) | null): void;
    /**
     * Loads all associated leaderboards that have defined deep links to this game activity definition.
     */
    loadLeaderboardsWithCompletionHandler$(completionHandler: ((leaderboards: _NSArray, error: _NSError) => void) | null): void;
    /** Asynchronously load the image. Error will be nil on success. */
    loadImageWithCompletionHandler$(completionHandler: ((_result: _NSImage, error: _NSError) => void) | null): void;
    /** The developer defined identifier for a given game activity. */
    identifier(): _NSString;
    /** The group identifier for the activity, if one exists. */
    groupIdentifier(): _NSString | null;
    /** A short title for the game activity. */
    title(): _NSString;
    /** A more detailed description of the game activity. */
    details(): _NSString | null;
    /** Default properties defined by the developer for this type of game activity. */
    defaultProperties(): _NSDictionary;
    /**
     * A fallback URL that can be used to construct a game-specific URL for players to share or join, if the joining device does not support the default URL.
     */
    fallbackURL(): _NSURL | null;
    /**
     * Whether the activity can be joined by others via a party code. - SeeAlso: ``-[GKGameActivityListener player:wantsToPlayGameActivity:completionHandler:]`` where you can receive and handle game activities that players want to play in a party with friends.
     */
    supportsPartyCode(): boolean;
    /**
     * The maximum number of participants that can join the activity. Returns nil when no maximum is set (unlimited players) or when player range is undefined. When not nil, the value is always greater than or equal to `minPlayers`.
     */
    maxPlayers(): _NSNumber;
    /** The minimum number of participants that can join the activity. */
    minPlayers(): _NSNumber;
    /**
     * True if the activity supports an unlimited number of players. False if maxPlayers is set to a defined limit or if no player range is provided.
     */
    supportsUnlimitedPlayers(): boolean;
    /** The play style of the game activity. */
    playStyle(): GKGameActivityPlayStyle;
    /** The release state of the game activity definition in App Store Connect. */
    releaseState(): GKReleaseState;
}
